<?php
namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Remote\FileUploader\Server;

class Sm000012000AnexoMedicaoController extends SMCrud
{
    protected $dataSourceName = 'fct_anexomedicao';
    protected $zhFileUploader;
    
	public function __construct ($crudService, $environment, Server $zhFileUploader)
    {
        parent::__construct($crudService, $environment);
        $this->zhFileUploader = $zhFileUploader;
    }
    
    public function save(Request $request, Response $response)
    {
        $row = $request->getDataSet()->getRows()[0];
        if ($row["__is_new"]) {
            $row["DSCAMINHO"] = $row["DSCAMINHO"][0]["path"];
        } else {
            /*O select da tela traz o tamanho dividido por 1024.
            Quando ta editando e manda salvar, tem que multiplicar por 1024 de volta.*/
            if (!empty($row["VRTAMANHO"])) {
                $row["VRTAMANHO"] *= 1024;
            }
        }
        parent::save($request, $response);
    }
    
    public function delete(Request $request, Response $response)
    {
        $row = $request->getRow();
        $this->zhFileUploader->deleteFile($row["DSCAMINHO"]);
        parent::delete($request, $response);
    }
}
