<?php

namespace Teknisa\SM\Service;
use Teknisa\SM\Factory\Sm00015000ApontamentoRecursosFactory;

class Sm00015000ApontamentoRecursosService{
        protected $apontamentoFactory;
    
        public function __construct (Sm00015000ApontamentoRecursosFactory $apontamentoFactory) {
            $this->apontamentoFactory = $apontamentoFactory;
        }
        /**
         * Valida o campo tipo no Banco
         */
        public function validaçãoDeCampoTipo($nrapropagendamento,$nrorg){
            
                 $params = array(
                "NRAPROPAGENDAMENTO" => $nrapropagendamento,
                "NRORG"         => $nrorg
                );
            
            $consulta = $this->apontamentoFactory->validaçãoDeCampoTipo($params);
            if (count($consulta) > 0)
                return $consulta[0];
            else
                return array();
        }
        /**
         * Retorna as horas apropriada para setar no campo entrada de cada novo resgitro de apontamento
         */
        public function validaHorarios($nrapropagendamento,$nrorg){
            $params = array(
                "NRAPROPAGENDAMENTO" => $nrapropagendamento,
                "NRORG"              => $nrorg
            );
          
            $dados = $this->apontamentoFactory->validaHorarios($params);
            
            if (count($dados) > 0)
                return $dados[0];
            else
                return array();
        }
         /**
         * Retorna as horas apropriada para setar no campo entrada de cada novo resgitro de apontamento
         */
        public function verificarApontamento($nrapropagendamento,$nrorg){
    
             $params = array(
                "NRAPROPAGENDAMENTO" => $nrapropagendamento,
                "NRORG"         => $nrorg
                );
          
             $dados = $this->apontamentoFactory->verificarApontamento($params);
           
             return $dados[0];
           
        }
         /*
        * Atualizando no banco o campo da tabela com a situação de apontamento confirmada
        */
       public function atualizarSituacao($nrapropagendamento,$nrorg){
            
             $params = array(
                "NRAPROPAGENDAMENTO" => $nrapropagendamento,
                "NRORG"         => $nrorg
                );
                
             $this->apontamentoFactory->atualizarSituacao($params);
        
       }
    }
?>