<?php
namespace Teknisa\Model\Teknisa\Repositories;
use OrganizationsManagement\Util\InstanceProvider;
use Doctrine\DBAL\Connection;
use OrganizationsManagement\Util\Utilities;

class BudgetItemFctItemorcamento extends \Doctrine\ORM\EntityRepository {
    
    public function getBudgetItem($nrorg, $filterString = '')
    {
        $query = <<<SQL
        SELECT *
          FROM (SELECT BUDITEMORC.ID, BUDIT.ID AS BUDGETID, BUDIT.NAME AS BUDGET_ITEM, BUDIT.VALUE, BUDIT.STATUS,
                       SERVORC.CDSERVORCA,
                       SERVORC.NMSERVORCA
                FROM BUDGET_ITEM BUDIT
                LEFT JOIN BUDGET_ITEM_FCT_ITEMORCAMENTO BUDITEMORC ON BUDITEMORC.BUDGET_ITEM_ID = BUDIT.ID AND BUDITEMORC.NRORG = :nrorg
                LEFT JOIN FCT_SERVICOORCA SERVORC ON SERVORC.CDSERVORCA = BUDITEMORC.CDSERVORCA AND SERVORC.NRORG = :nrorg
                    WHERE BUDIT.STATUS <> 'D'
                      AND BUDIT.ORGANIZATION_ID = :nrorg
                    ORDER BY BUDIT.NAME, SERVORC.CDSERVORCA ASC)
         WHERE 1 = 1
         $filterString
SQL;
        $params = array(
            "nrorg" => $nrorg
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);

    }
    
    public function updateValueBudgetItem($budgetid, $cdServOrca, $nrorg)
    {
         $query = <<<SQL
            UPDATE BUDGET_ITEM SET VALUE = (
                SELECT ITPREC.VRPRECO
                 FROM FCT_SERVICOORCA SERV
                  INNER JOIN FCT_ITPRECBASESERV ITPREC
                    ON SERV.CDSERVORCA = ITPREC.CDSERVORCA
                   AND SERV.NRORG      = ITPREC.NRORG
                WHERE SERV.CDSERVORCA = :cdServOrca AND SERV.NRORG = :nrorg
            ) WHERE ID = :budgetid AND ORGANIZATION_ID = :nrorg
SQL;
        $params = array(
                "budgetid" => $budgetid,
                "cdServOrca" => $cdServOrca,
                "nrorg" => $nrorg
            );
            
        try {
            $std = $this->getEntityManager()->getConnection()->prepare($query);
            $std->execute($params);
        } catch (Exception $e) {
            throw new \Exception($e->getMessage());
        }
    }
    
    public function getNameServiceSM($filterString = '', $nrorg, $limit, $offset)
    {
        $query = <<<SQL
        SELECT * FROM (
        SELECT SERV.CDSERVORCA,
               SERV.NMSERVORCA,
               ITPREC.VRPRECO
          FROM FCT_SERVICOORCA SERV
         INNER JOIN FCT_ITPRECBASESERV ITPREC
            ON SERV.CDSERVORCA = ITPREC.CDSERVORCA
           AND SERV.NRORG      = ITPREC.NRORG
         WHERE ITPREC.CDPRECBASESERV = (SELECT CDPRECBASESERVCUST
                                          FROM FCT_PARAMETROGERAL
                                         WHERE ROWNUM = 1))
            WHERE NMSERVORCA IS NOT NULL
            $filterString
SQL;
        $params = array(
                "nrorg" => $nrorg
            );
        $query = Utilities::getPaginatedQuery($query, $limit, $offset);
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function findBudgetItems($filterString = '', $nrorg, $limit, $offset)
    {
        $query = <<<SQL
        SELECT *
          FROM (SELECT ID, NAME, VALUE, STATUS
                  FROM BUDGET_ITEM
                 WHERE STATUS <> 'D'
                   AND ORGANIZATION_ID = :nrorg)
         WHERE 1 = 1
            $filterString
SQL;
        $params = array(
                "nrorg" => $nrorg
            );
        $query = Utilities::getPaginatedQuery($query, $limit, $offset);
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }


    public function getBudgetItemPrices($nrorg, $filterString = '')
    {
        $query = <<<SQL
        SELECT *
          FROM (SELECT BIP.ID, BIP.ID_BUDGET_ITEM, BIP.NRMOEDA, MO.NMMOEDA, BIP.VALUE
                  FROM BUDGET_ITEM_PRICES BIP
                  JOIN FCT_MOEDA MO
                    ON MO.NRMOEDA = BIP.NRMOEDA)
         WHERE 1 = 1
         $filterString
SQL;
        $params = array(
            "nrorg" => $nrorg
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);

    }

    public function findMoeda($filterString = '', $nrorg, $limit, $offset)
    {
        $query = <<<SQL
        SELECT *
          FROM (SELECT NRMOEDA, NMMOEDA
                  FROM FCT_MOEDA
                 WHERE IDATIVO = 'S')
         WHERE 1 = 1
         $filterString
SQL;
        $params = array(
            "nrorg" => $nrorg
        );

        $query = Utilities::getPaginatedQuery($query, $limit, $offset);
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);

    }

    
}